﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UCCApiConferenceSample.UCCClasses;
using Microsoft.Office.Interop.UccApi;

namespace UCCApiConferenceSample
{
  public partial class Form1 : Form
  {
    private MyPlatform myPlatform = new MyPlatform();
    private MyEndpoint myEndpoint;
    private MySubscriptionManager mySubscriptionManager;
    public MyIMSession myIMSession;
    public string FocusUri;
    private MyConferenceSession confSession;

    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      myPlatform.CreatePlatform();
    }

    private void button2_Click(object sender, EventArgs e)
    {
      myEndpoint = new MyEndpoint();
      myEndpoint.form1 = this;      

      string user = textBox1.Text;
      string password = textBox2.Text;
      

      myEndpoint.EnableEndpoint(this.myPlatform, "sip:" + user + "@domain.com", user + "@ae.com.br", password, null, "server", Microsoft.Office.Interop.UccApi.UCC_TRANSPORT_MODE.UCCTM_TLS);
    }

    private void button3_Click(object sender, EventArgs e)
    {
      if (myEndpoint.confSession == null)
      {
        MessageBox.Show("No conference");
        return;
      }
      myEndpoint.confSession.imSession.SendMessage("text/plain", "Teste de mensagem", null);
    }

    private void button4_Click(object sender, EventArgs e)
    {
      if (myEndpoint == null)
      {
        MessageBox.Show("Enable the endpoint first");
        return;
      }

      mySubscriptionManager = new MySubscriptionManager(myEndpoint);
      mySubscriptionManager.SubscribeServerConfiguration();

      /*mySubscriptionManager.SubscribeContainers();
      mySubscriptionManager.SubscribeState();
      mySubscriptionManager.SubscribeContacts();*/
        
    }

    private void button5_Click(object sender, EventArgs e)
    {
      MyPublicationManager myPublicationManager = new MyPublicationManager();
      myPublicationManager.PublishPresence(myEndpoint, 0x20000000, UCC_CATEGORY_INSTANCE_EXPIRE_TYPE.UCCCIET_USER, 3500, UCC_PRESENCE_STATE_TYPE.UCCPST_USER_STATE, true);

      MyPublicationManager myPublicationManager2 = new MyPublicationManager();
      myPublicationManager2.PublishPresence(myEndpoint, 0x30000000, UCC_CATEGORY_INSTANCE_EXPIRE_TYPE.UCCCIET_DEVICE, 3500, UCC_PRESENCE_STATE_TYPE.UCCPST_MACHINE_STATE, false);
    }

    private void button6_Click(object sender, EventArgs e)
    {
      myIMSession = new MyIMSession();
      myIMSession.CreateIMSession(myEndpoint, "sip:otheruser@domain.com");
    }

    private void button7_Click(object sender, EventArgs e)
    {
      myIMSession.SendMessage("Hello!");
    }

    private void button8_Click(object sender, EventArgs e)
    {
      confSession = new MyConferenceSession();
      confSession.ScheduleConference(myEndpoint, mySubscriptionManager.FocusUri.Value);      
    }

    private void button9_Click(object sender, EventArgs e)
    {
      confSession.CreateConferenceSession(myEndpoint, confSession.conferenceUri);
    }

    private void button10_Click(object sender, EventArgs e)
    {
      confSession.InviteUser(myEndpoint.uccEndpoint, "sip:otheruser@domain.com", confSession.conferenceUri);
    }

  }
}
