﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Interop.UccApi;
using System.Windows.Forms;

namespace UCCApiConferenceSample.UCCClasses
{
  public class MyContact : _IUccPresentityEvents, _IUccCategoryContextEvents, _IUccCategoryInstanceEvents
  {    

    public void HandleContactEvents(IUccContact contact, MyEndpoint myEndpoint)
    {
      IUccSubscriptionManager subscriptionManager = (IUccSubscriptionManager)myEndpoint.uccEndpoint;

      IUccSubscription theContactSubscription = subscriptionManager.CreateSubscription(null);

      UccPresentity presentity = theContactSubscription.CreatePresentity(contact.Uri, null);
      ComHelper.Advise<_IUccPresentityEvents>(presentity, this);
      theContactSubscription.AddPresentity(presentity);
      theContactSubscription.AddCategoryName("containers");
      theContactSubscription.AddCategoryName("contactCard");
      theContactSubscription.AddCategoryName("state");
      theContactSubscription.Subscribe(null);      
    }

    public void OnCategoryInstanceAdded(IUccCategoryContext pCategoryCtxt, UccCategoryInstanceEvent pCategoryInstanceEvent)
    {
      if (pCategoryCtxt.Name == "contactCard")
      {
      }
      else if (pCategoryCtxt.Name == "state")
      {        
        IUccPresenceStateInstance state = (IUccPresenceStateInstance)pCategoryInstanceEvent.CategoryInstance;
        ComHelper.Advise<_IUccCategoryInstanceEvents>(state, this);
        MessageBox.Show(state.Availability.ToString());
      }
      else if (pCategoryCtxt.Name == "containers")
      {
      }
    }

    public void OnCategoryInstanceRemoved(IUccCategoryContext pCategoryCtxt, UccCategoryInstanceEvent pCategoryInstanceEvent)
    {
      
    }
  
    public void  OnCategoryInstanceValueModified(IUccCategoryInstance pCategoryInstance, object pEventData)
    {
      IUccPresenceStateInstance state = (IUccPresenceStateInstance)pCategoryInstance;     
      MessageBox.Show(state.Availability.ToString());      
    }

    public void OnCategoryContextAdded(UccPresentity pPresentity, UccCategoryContextEvent pCategoryCtxtEvent)
    {
      ComHelper.Advise<_IUccCategoryContextEvents>(pCategoryCtxtEvent.CategoryContext, this);
    }

    public void OnCategoryContextRemoved(UccPresentity pPresentity, UccCategoryContextEvent pCategoryCtxtEvent)
    {
      
    }
  }
}
