﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Interop.UccApi;
using System.Windows.Forms;

namespace UCCApiConferenceSample.UCCClasses
{
  public class MyIMSession : _IUccInstantMessagingSessionEvents, _IUccInstantMessagingSessionParticipantEvents
  {
    private IUccInstantMessagingSession imSession;

    public void CreateIMSession(MyEndpoint endpoint, string user)
    {
      IUccSessionManager sessionManager = (IUccSessionManager)endpoint.uccEndpoint;

      UccUriManager uriManager = new UccUriManager();      
      UccUri destUser = uriManager.ParseUri(user);

      IUccSession session = sessionManager.CreateSession(UCC_SESSION_TYPE.UCCST_INSTANT_MESSAGING, null);
      IUccSessionParticipant participant = session.CreateParticipant(destUser, null);
      ComHelper.Advise<_IUccInstantMessagingSessionParticipantEvents>(participant, this);     
      session.AddParticipant(participant);

      imSession = (IUccInstantMessagingSession)session;
      ComHelper.Advise<_IUccInstantMessagingSessionEvents>(imSession, this);     
    }

    public void ProcessIncomingSession(IUccIncomingSessionEvent pEventData)
    {
      imSession = (IUccInstantMessagingSession)pEventData.Session;

      IUccSessionParticipant participant = (IUccSessionParticipant) pEventData.Inviter;
      ComHelper.Advise<_IUccInstantMessagingSessionParticipantEvents>(participant, this);     
    }

    public void SendMessage(string msg)
    {
      imSession.SendMessage("text/plain", msg);
    }

    public void OnSendMessage(UccInstantMessagingSession pEventSource, UccSessionOperationEvent pEventData)
    {
      
    }

    public void OnComposing(UccInstantMessagingSessionParticipant pEventSource, UccInstantMessagingComposingEvent pEventData)
    {
      
    }

    public void OnIdle(UccInstantMessagingSessionParticipant pEventSource, UccInstantMessagingComposingEvent pEventData)
    {
      
    }

    public void OnInstantMessageReceived(UccInstantMessagingSessionParticipant pEventSource, UccIncomingInstantMessageEvent pEventData)
    {
      MessageBox.Show(pEventData.Content);
    }
  }
}
