﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Interop.UccApi;

namespace UCCApiConferenceSample.UCCClasses
{
  public class MyPublicationManager : _IUccPublicationEvent
  {

    public void PublishPresence(MyEndpoint Endpoint, int instanceId, UCC_CATEGORY_INSTANCE_EXPIRE_TYPE expireType, int availability,
      UCC_PRESENCE_STATE_TYPE presenceStateType, bool manual)
    {
      IUccPublicationManager pubManager = (IUccPublicationManager)Endpoint.uccEndpoint;

      IUccCategoryInstance pubInstance = (IUccCategoryInstance)pubManager.CreatePublishableCategoryInstance("state", 2, instanceId, expireType, 0);
      
      IUccPresenceStateInstance state = (IUccPresenceStateInstance)pubInstance;
      state.Availability = (int)availability;
      state.Type = presenceStateType;
      state.IsManual = manual;

      pubInstance.PublicationOperation = UCC_PUBLICATION_OPERATION_TYPE.UCCPOT_ADD;
      
      IUccPublication pub = pubManager.CreatePublication();
      ComHelper.Advise<_IUccPublicationEvent>(pub, this);
      pub.AddPublishableCategoryInstance(pubInstance);      
      pub.Publish();
    }

    public void OnPublish(IUccPublication pPublication, IUccOperationProgressEvent pPublicationEventInfo)
    {
      if (!pPublicationEventInfo.IsComplete)
        return;

      if (pPublicationEventInfo.StatusCode != 0)
        throw new Exception("Error");
    }
  }
}
